<?php

declare(strict_types=1);

namespace Pinpoint\Conesso\Api\Data;

interface ContactInterface extends \Magento\Framework\Api\ExtensibleDataInterface
{
    const CONTACT_ID = 'contact_id';
    const IS_GUEST = 'is_guest';
    const CONESSO_ID = 'conesso_id';
    const CUSTOMER_ID = 'customer_id';
    const WEBSITE_ID = 'website_id';
    const STORE_ID = 'store_id';
    const EMAIL = 'email';
    const IS_SUBSCRIBER = 'is_subscriber';
    const IS_EMAIL_IMPORTED = 'is_email_imported';
    const IS_SUBSCRIBER_IMPORTED = 'is_subscriber_imported';
    const LAST_SUBSCRIBED_AT = 'last_subscribed_at';

    /**
     * Get contact_id
     * @return int|null
     */
    public function getContactId();

    /**
     * Set contact_id
     * @param int $contactId
     * @return \Pinpoint\Conesso\Api\Data\ContactInterface
     */
    public function setContactId($contactId);

    /**
     * Get is_guest
     * @return int|null
     */
    public function getIsGuest();

    /**
     * Set is_guest
     * @param int $isGuest
     * @return \Pinpoint\Conesso\Api\Data\ContactInterface
     */
    public function setIsGuest($isGuest);

    /**
     * Get conesso_id
     * @return int|null
     */
    public function getConessoId();

    /**
     * Set conesso_id
     * @param int $conessoId
     * @return \Pinpoint\Conesso\Api\Data\ContactInterface
     */
    public function setConessoId($conessoId);

    /**
     * Get customer_id
     * @return int|null
     */
    public function getCustomerId();

    /**
     * Set customer_id
     * @param int $customerId
     * @return \Pinpoint\Conesso\Api\Data\ContactInterface
     */
    public function setCustomerId($customerId);

    /**
     * Get website_id
     * @return int|null
     */
    public function getWebsiteId();

    /**
     * Set website_id
     * @param int $websiteId
     * @return \Pinpoint\Conesso\Api\Data\ContactInterface
     */
    public function setWebsiteId($websiteId);

    /**
     * Get store_id
     * @return int|null
     */
    public function getStoreId();

    /**
     * Set store_id
     * @param int $storeId
     * @return \Pinpoint\Conesso\Api\Data\ContactInterface
     */
    public function setStoreId($storeId);

    /**
     * Get email
     * @return string|null
     */
    public function getEmail();

    /**
     * Set email
     * @param string $email
     * @return \Pinpoint\Conesso\Api\Data\ContactInterface
     */
    public function setEmail($email);

    /**
     * Get is_subscriber
     * @return int|null
     */
    public function getIsSubscriber();

    /**
     * Set is_subscriber
     * @param int $isSubscriber
     * @return \Pinpoint\Conesso\Api\Data\ContactInterface
     */
    public function setIsSubscriber($isSubscriber);

    /**
     * Get is_email_imported
     * @return int|null
     */
    public function getIsEmailImported();

    /**
     * Set is_email_imported
     * @param int $isEmailImported
     * @return \Pinpoint\Conesso\Api\Data\ContactInterface
     */
    public function setIsEmailImported($isEmailImported);

    /**
     * Get is_subscriber_imported
     * @return int|null
     */
    public function getIsSubscriberImported();

    /**
     * Set is_subscriber_imported
     * @param int $isSubscriberImported
     * @return \Pinpoint\Conesso\Api\Data\ContactInterface
     */
    public function setIsSubscriberImported($isSubscriberImported);

    /**
     * Get last_subscribed_at
     * @return int|null
     */
    public function getLastSubscribedAt();

    /**
     * Set last_subscribed_at
     * @param int $lastSubscribedAt
     * @return \Pinpoint\Conesso\Api\Data\ContactInterface
     */
    public function setLastSubscribedAt($lastSubscribedAt);
}

