<?php

namespace Pinpoint\Conesso\Api;

interface EndpointsInterface
{
    public const CONESSO_PRODUCTION_URL = 'https://api.conesso.io';
    public const CONESSO_QA_URL = 'https://api.qa.conesso.io';

    //Carts
    public const CARTS = [
        'endpoint' => '%s/v2/carts',
        'methods' => ['GET', 'POST']
    ];

    public const CARTS_ID = [
        'endpoint' => '%s/v2/carts/{id}',
        'methods' => ['GET', 'PUT', 'DELETE']
    ];


    //Contact Unsubscribe
    public const CONTACT_OPTIN = [
        'endpoint' => '%s/v2/contacts/optin',
        'methods' => ['POST']
    ];

    public const CONTACT_UNSUBSCRIBE = [
        'endpoint' => '%s/v2/contacts/unsubscribe',
        'methods' => ['POST']
    ];


    //Contact-custom-Fields
    public const CUSTOM_FIELDS = [
        'endpoint' => '%s/v2/custom-fields',
        'methods' => ['GET', 'POST']
    ];

    public const CUSTOM_FIELDS_ID = [
        'endpoint' => '%s/v2/custom-fields/{id}',
        'methods' => ['GET', 'PUT', 'DELETE']
    ];


    //Contacts
    public const CONTACTS = [
        'endpoint' => '%s/v2/contacts',
        'methods' => ['GET', 'POST']
    ];

    public const CONTACTS_ID = [
        'endpoint' => '%s/v2/contacts/{id}',
        'methods' => ['GET', 'PUT', 'DELETE']
    ];

    public const CONTACTS_ID_EMAILS = [
        'endpoint' => '%s/v2/contacts/{id}/emails',
        'methods' => ['GET']
    ];


    //Email send test
    public const CONTACTS_ID_EMAIL_TEST = [
        'endpoint' => '%s/v2/emails/{id}/test',
        'methods' => ['POST']
    ];

    public const CONTACTS_ID_EMAIL_TEST_LIST = [
        'endpoint' => '%s/v2/emails/{id}/test/{listId}',
        'methods' => ['POST']
    ];


    //Emails
    public const EMAILS = [
        'endpoint' => '%s/v2/emails',
        'methods' => ['GET', 'POST']
    ];

    public const EMAILS_ID = [
        'endpoint' => '%s/v2/emails/{id}',
        'methods' => ['GET', 'PUT', 'DELETE']
    ];

    public const EMAILS_ID_TRIGGER = [
        'endpoint' => '%s/v2/emails/{id}/trigger',
        'methods' => ['PUT']
    ];

    public const EMAILS_MERGETAGS_ID = [
        'endpoint' => '%s/v2/emails/mergetags/{id}',
        'methods' => ['POST']
    ];

    public const EMAILS_URL = [
        'endpoint' => '%s/v2/emails/url',
        'methods' => ['GET']
    ];


    //Emails Content
    public const EMAILS_CONTENT = [
        'endpoint' => '%s/v2/emails/{id}/variations/{variationId}/versions',
        'methods' => ['GET']
    ];


    //Lists
    public const LISTS = [
        'endpoint' => '%s/v2/lists',
        'methods' => ['GET', 'POST']
    ];

    public const LISTS_ID = [
        'endpoint' => '%s/v2/lists/{id}',
        'methods' => ['GET', 'PUT', 'DELETE']
    ];


    //Orders
    public const ORDERS = [
        'endpoint' => '%s/v2/orders',
        'methods' => ['GET', 'POST']
    ];

    public const ORDERS_ID = [
        'endpoint' => '%s/v2/orders/{id}',
        'methods' => ['GET', 'PUT', 'DELETE']
    ];

    public const ORDERS_EVENTS = [
        'endpoint' => '%s/v2/orders/events',
        'methods' => ['GET', 'POST']
    ];

    public const ORDERS_EVENTS_ID = [
        'endpoint' => '%s/v2/orders/events/{id}',
        'methods' => ['GET', 'PUT']
    ];


    //Products
    public const PRODUCTS = [
        'endpoint' => '%s/v2/products',
        'methods' => ['GET', 'POST']
    ];

    public const PRODUCTS_ID = [
        'endpoint' => '%s/v2/products/{id}',
        'methods' => ['GET', 'PUT', 'DELETE']
    ];

    public const PRODUCTS_STOCK_ID = [
        'endpoint' => '%s/v2/products/stock/{id}',
        'methods' => ['GET', 'PUT']
    ];


    //Segments
    public const SEGMENTS = [
        'endpoint' => '%s/v2/segments',
        'methods' => ['GET', 'POST']
    ];

    public const SEGMENTS_ID = [
        'endpoint' => '%s/v2/segments/{id}',
        'methods' => ['GET', 'PUT', 'DELETE']
    ];

    public const SEGMENTS_ID_REFRESH = [
        'endpoint' => '%s/v2/segments/{id}/refresh',
        'methods' => ['POST']
    ];
}
