<?php

namespace Pinpoint\Conesso\Block\Adminhtml\System\Config;

use Magento\Backend\Block\Template\Context;
use Magento\Config\Block\System\Config\Form\Field;
use Magento\Framework\Data\Form\Element\AbstractElement;

/**
 * Class TestConnection
 * @package Pinpoint\Conesso\Block\Adminhtml\System\Config
 */
class TestConnectionProd extends Field
{
    /**
     * @var string
     */
    protected $_template = 'Pinpoint_Conesso::system/config/testconnection.phtml';

    /**
     * @param Context $context
     * @param array   $data
     */
    public function __construct(
        Context $context,
        array $data = []
    ) {
        parent::__construct($context, $data);
    }

    /**
     * Remove scope label
     *
     * @param  AbstractElement $element
     * @return string
     */
    public function render(AbstractElement $element)
    {
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();
        return parent::render($element);
    }

    /**
     * Return element html
     *
     * @param  AbstractElement $element
     * @return string
     */
    protected function _getElementHtml(AbstractElement $element)
    {
        return $this->_toHtml();
    }

    /**
     * Return ajax url for collect button
     *
     * @return string
     */
    public function getAjaxUrl()
    {
        return $this->getUrl('pinpoint_conesso/config/testconnection', ['type' => 'prod']);
    }

    /**
     * Generate collect button html
     *
     * @return string
     */
    public function getButtonHtml()
    {
        $button = $this->getLayout()->createBlock(
            'Magento\Backend\Block\Widget\Button'
        )->setData(
            [
                'id' => 'testconnection_button_prod',
                'label' => __('Check Connection - Prod'),
            ]
        );

        return $button->toHtml();
    }

    /**
     *
     * @return string
     */
    public function getButtonId()
    {
        return 'testconnection_button_prod';
    }
}
