<?php

namespace Pinpoint\Conesso\Controller\Adminhtml\Config;

use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Filter\StripTags;
use Pinpoint\Conesso\Model\Api\Service;

class Testconnection extends Action
{
    /**
     * @var Service
     */
    private $service;

    /**
     * @var JsonFactory
     */
    private $resultJsonFactory;

    /**
     * @var StripTags
     */
    private $tagFilter;

    /**
     * @param Context        $context
     * @param JsonFactory    $resultJsonFactory
     * @param StripTags      $tagFilter
     * @param Service        $service
     */
    public function __construct(
        Context $context,
        JsonFactory $resultJsonFactory,
        StripTags $tagFilter,
        Service $service
    ) {
        parent::__construct($context);
        $this->resultJsonFactory = $resultJsonFactory;
        $this->tagFilter = $tagFilter;
        $this->service = $service;
    }

    /**
     * Check for connection to server
     *
     * @return \Magento\Framework\Controller\Result\Json
     * @throws \Exception
     */
    public function execute()
    {
        $mode = $this->getRequest()->getParam('type');
        $accountInfo = $this->service->checkConnection($mode);

        /** @var \Magento\Framework\Controller\Result\Json $resultJson */
        $resultJson = $this->resultJsonFactory->create();
        return $resultJson->setData($accountInfo);
    }
}
