<?php

declare(strict_types=1);

namespace Pinpoint\Conesso\Model\ResourceModel;

use Magento\Framework\Event\ManagerInterface;
use Magento\Framework\Model\ResourceModel\Db\Context;

class Contact extends \Magento\Framework\Model\ResourceModel\Db\AbstractDb
{
    /**
     * @param Context $context
     * @param ManagerInterface $eventManager
     * @param string $connectionName
     */
    public function __construct(
        Context $context,
        ManagerInterface $eventManager,
        $connectionName = null
    ) {
        parent::__construct($context, $connectionName);
        $this->_eventManager = $eventManager;
    }

    /**
     * Define resource model
     *
     * @return void
     */
    protected function _construct()
    {
        $this->_init('conesso_contact', 'contact_id');
    }
}

